﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Text;
using System.IO;
using System.Reflection;

namespace TradePumpNet
{
    public class Logger
    {
        static EventLogEntryType _logLevel = EventLogEntryType.Information;

        public static EventLogEntryType LogLevel
        {
            get
            {
                return _logLevel;
            }
            set
            {
                _logLevel = value;
            }
        }

        public static void Log(string Message, EventLogEntryType LogEntryType)
        {
            
            if (LogEntryType <= _logLevel)
            {
                try
                {
                    LogToFile(Message);
                    //EventLog.WriteEntry("Quote Receiver", Message, LogEntryType); 
                    //Debug.WriteLine(Message);
                    //Console.WriteLine(Message);
                }
                catch { }
            }
        }

        public static void Log(Exception exc, EventLogEntryType LogEntryType)
        {
            if (LogEntryType <= _logLevel)
            {
                Log(exc.ToString(), LogEntryType);
            }
        }

        public static void Log(string msg)
        {
            Log(msg, EventLogEntryType.Information );
        }

        public static void Log(Exception exc)
        {
            Log(exc.ToString(), EventLogEntryType.Error);
        }

        public static void LogToFile(string line)
        {
            File.AppendAllLines(Path.Combine(GetCurrentExecutingDirectory(),"TradePumpNet.log"), new List<string>() { line });
        }

        static string GetCurrentExecutingDirectory()
        {
            string filePath = new Uri(Assembly.GetExecutingAssembly().CodeBase).LocalPath;
            return Path.GetDirectoryName(filePath);
        }
    }
}
